VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SimpleFtpClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function InternetConnect Lib "wininet.dll" Alias _
        "InternetConnectA" (ByVal hInternetSession As Long, _
        ByVal sServerName As String, ByVal nServerPort As Integer, _
        ByVal sUsername As String, ByVal sPassword As String, _
        ByVal lService As Long, ByVal lFlags As Long, ByVal _
        lContext As Long) As Long

Private Declare Function InternetOpen Lib "wininet.dll" Alias _
        "InternetOpenA" (ByVal sAgent As String, ByVal lAccessType _
        As Long, ByVal sProxyName As String, ByVal sProxyBypass _
        As String, ByVal lFlags As Long) As Long
       
Private Declare Function InternetCloseHandle Lib "wininet.dll" _
        (ByVal hInet As Long) As Integer

Private Declare Function FtpSetCurrentDirectory Lib "wininet.dll" _
        Alias "FtpSetCurrentDirectoryA" (ByVal hFtpSession As _
        Long, ByVal lpszDirectory As String) As Long
        
Private Declare Function FtpFindFirstFile Lib "wininet.dll" _
        Alias "FtpFindFirstFileA" (ByVal hFtpSession As Long, _
        ByVal lpszSearchFile As String, lpFindFileData As _
        WIN32_FIND_DATA, ByVal dwFlags As Long, ByVal dwContent _
        As Long) As Long
        
Private Declare Function InternetFindNextFile Lib "wininet.dll" _
        Alias "InternetFindNextFileA" (ByVal hFind As Long, _
        lpvFindData As WIN32_FIND_DATA) As Long

Private Declare Function FtpGetFile Lib "wininet.dll" Alias _
        "FtpGetFileA" (ByVal hFtpSession As Long, ByVal _
        lpszRemoteFile As String, ByVal lpszNewFile As String, _
        ByVal fFailIfExists As Boolean, ByVal dwFlagsAndAttributes _
        As Long, ByVal dwFlags As Long, ByVal dwContext As Long) _
        As Long

Private Declare Function FtpPutFile Lib "wininet.dll" Alias _
        "FtpPutFileA" (ByVal hFtpSession As Long, ByVal _
        lpszLocalFile As String, ByVal lpszRemoteFile As String, _
        ByVal dwFlags As Long, ByVal dwContext As Long) As Long
       
Private Declare Function FtpDeleteFile Lib "wininet.dll" _
        Alias "FtpDeleteFileA" (ByVal hFtpSession As Long, _
        ByVal lpszFileName As String) As Long

Private Declare Function FtpRenameFile Lib "wininet.dll" _
        Alias "FtpRenameFileA" (ByVal hFtpSession As Long, _
        ByVal lpszFromFileName As String, ByVal lpszToFileName _
        As String) As Long
        
Private Declare Function FtpCreateDirectory Lib "wininet" _
        Alias "FtpCreateDirectoryA" (ByVal hFtpSession As _
        Long, ByVal lpszDirectory As String) As Long

Private Declare Function FtpRemoveDirectory Lib "wininet" _
        Alias "FtpRemoveDirectoryA" (ByVal hFtpSession As _
        Long, ByVal lpszDirectory As String) As Long

Private Declare Function InternetGetLastResponseInfo Lib _
        "wininet.dll" Alias "InternetGetLastResponseInfoA" _
        (lpdwError As Long, ByVal lpszBuffer As String, _
        lpdwBufferLength As Long) As Long
    
Const ERROR_NO_MORE_FILES = 18
Const ERROR_INTERNET_EXTENDED_ERROR = 12003

Const FTP_TRANSFER_TYPE_BINARY = &H0
Const FTP_TRANSFER_TYPE_ASCII = &H1

Const INTERNET_FLAG_PASSIVE = &H8000000
Const INTERNET_FLAG_RELOAD = &H80000000
Const INTERNET_FLAG_KEEP_CONNECTION = &H400000
Const INTERNET_FLAG_MULTIPART = &H200000

Const INTERNET_OPEN_TYPE_PRECONFIG = 0
Const INTERNET_OPEN_TYPE_DIRECT = 1
Const INTERNET_OPEN_TYPE_PROXY = 3

Const INTERNET_INVALID_PORT_NUMBER = 0

Const INTERNET_SERVICE_FTP = 1
Const INTERNET_SERVICE_GOPHER = 2
Const INTERNET_SERVICE_HTTP = 3

Private Declare Function FileTimeToSystemTime Lib "kernel32" _
        (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) _
        As Long
        
Private Type SYSTEMTIME
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type

Private hOpen As Long
Private hConnection As Long

Public Sub Cancel()
    Disconnect
End Sub

Public Sub Disconnect()
    If hConnection <> 0 Then InternetCloseHandle hConnection
    If hOpen <> 0 Then InternetCloseHandle hOpen
    hConnection = 0
    hOpen = 0
End Sub

Public Function IsConnected() As Boolean
    IsConnected = (hConnection <> 0)
End Function

Public Function Connect(ByVal Host As String, Optional ByVal Port As Long = 21, Optional ByVal User As String = "Anonymous", Optional ByVal Pass As String = "me@myself.net") As Long '0 = Error
    hOpen = InternetOpen("FTP", 1, vbNullString, vbNullString, 0)
    If hOpen = 0 Then
        Connect = 0
        Exit Function
    End If

    hConnection = InternetConnect(hOpen, Host, Port, User, Pass, 1, 0, 0)
    If hConnection = 0 Then
        InternetCloseHandle hOpen
        hOpen = 0
        Connect = 0
        Exit Function
    End If

    Connect = hConnection
End Function

Public Function SendFile(ByVal LocalFile As String, ByVal RemoteFile As String) As Long '0 = Fehler
    SendFile = FtpPutFile(hConnection, LocalFile, RemoteFile, &H0, 0)
End Function

Public Function GetFile(ByVal RemoteFile As String, ByVal LocalFile As String) As Long '0 = Fehler
    GetFile = FtpGetFile(hConnection, RemoteFile, LocalFile, False, &H0, &H0, 0)
End Function

Public Function ChangeDir(ByVal Path As String) As Long '0 = Fehler
    ChangeDir = FtpSetCurrentDirectory(hConnection, Path)
End Function

Public Function GetFirstFile(ByRef FileName As String) As Long
    Dim Data As WIN32_FIND_DATA
    GetFirstFile = FtpFindFirstFile(hConnection, "*", Data, &H0, 0)
    FileName = ZTrim$(Data.cFileName)
End Function

Public Function GetNextFile(ByVal hFind As Long, ByRef FileName As String) As Long
    Dim Data As WIN32_FIND_DATA
    GetNextFile = InternetFindNextFile(hFind, Data)
    FileName = ZTrim$(Data.cFileName)
End Function

Private Sub Class_Initialize()
    NewInstanz "SimpleFtpClient"
End Sub

Private Sub Class_Terminate()
    Disconnect
    UnloadInstanz "SimpleFtpClient"
End Sub
